<template>
	<mind-layout>
		<template slot="toolbar-actions">
			<el-radio-group v-model="rawMode"  size="small" style="margin-right: 20px; margin-bottom: 2px">
				<el-radio-button  :label="false"  title="Modo Formulario"><i class="el-icon-edit-outline"></i></el-radio-button>
				<el-radio-button :label="true" title="Modo RAW"><i class="el-icon-tickets" /></el-radio-button>
			</el-radio-group>
			<el-button type="primary" size="small" @click="onSubmit">Aplicar</el-button>
		</template>
		<mind-form :footer="false">
			<el-row wrap>
				<el-col :xs="24" :lg="12" :xl="8">
					<el-form-item  label="Nombre">
						<el-input  v-model="playListName">
							<span slot="prepend">playlist-</span>
						</el-input>
					</el-form-item>
				</el-col>
			</el-row>
			<dialplan-exten :readonly="false" :raw="rawMode" v-model="extensionData" :show-exten="false" :show-prio="false"
				:available-commands="listaComandos" />
		</mind-form>
	</mind-layout>
</template>
<script>
import {Rest} from '@/../modules/mind-core-vue'
import dialplanExten from '@/components/dialplan-exten'
// import mnemonics from '@/mnemonics/sip-trunk'


export default {
	components: {
		dialplanExten,

	},
	async created(){
		let id = this.$route.params.id
		this.api = new Rest({
			uri: `api/ami/playlists`, 
			key: 'name'
		})

		if(!id || id == 'new') {
			this.isNew = true
			this.recurso = { category: null, options: []	}
		} else {
			this.playListID = id
			this.fetch(id)
		}
	},
	computed:{
		extensionData:{
			get(){
				return this.recurso.options || []
			},
			set(v) {
				this.recurso.options = v
			}
		},
		playListName: {
			get() {
				
				return this.recurso.category ? this.recurso.category.replace("playlist-", "") : this.recurso.category
			},
			set(v) {
				this.recurso.category = `playlist-${v.replace(' ', '')}`
			}
		}
	},

	methods: {
		async fetch(id) {
			this.recurso = await this.api.Fetch(id)
			.catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
		},


		async onSubmit() {
			// this.recurso.category = this.recurso.category.replace
			if(this.isNew) {
				this.api.Post(this.recurso)
					.then(()=>{
						this.fetch(this.recurso.category)
						this.$message({
							showClose: true,
							type: 'success',
							message: "Playlist creada"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			} else {
				this.api.Patch(this.recurso, this.playListID)
					.then(()=>{
						this.fetch(this.recurso.category)
						this.$message({
							showClose: true,
							type: 'success',
							message: "Se aplicaron los cambios"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})

			}
		}
	},
	filters: {
		join(v) {
			if(Array.isArray(v)) {
				return v.join(', ')
			}
			return v
		}
	},
	data() {
		return {
			isNew: false,
			recurso: {
			},
			api: null,
			playListID: null,
			rawMode: false,
			listaComandos:[
				{"type":"app","name":"MP3Player", "tags":[""], "params":"Location"},
				{"type":"app","name":"Playback", "tags":["playback"], "params":"filename&[filename2[&...]],[options]"},
				{"type":"app","name":"PlayTones", "tags":["playback"], "params":"arg"},
				{"type":"app","name":"SayAlpha", "tags":["playback"], "params":"string"},
				{"type":"app","name":"SayDigits", "tags":["playback"], "params":"digits"},
				{"type":"app","name":"SayNumber", "tags":["playback"], "params":"digits,[gender]"},
				{"type":"app","name":"SayPhonetic", "tags":["playback"], "params":"string"},
				{"type":"app","name":"SayUnixTime", "tags":["playback"], "params":"[unixtime,[timezone,[format,[options]]]]"},
				{"type":"app","name":"SendDTMF", "tags":["playback"], "params":"digits,[timeout_ms,[duration_ms,[channel]]]"},

			]
		}
	}
}
</script>
<style lang="css" >
.el-select {
	width:100%;
}



</style>